; ________________________________________________
; |      Controllo per timer 4 digit 16F628A     |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      :  7/08/07                       |
; |______________________________________________|

;_______________________________________________________Inizializza timer
Sys_Init:
;Inizializza il timer 1
;Registri modificati:
;       sistema
;       b_CONTROLLO
;       b_STATO
;       b_SW1_BUFF
;       b_SW2_BUFF
;       b_SW3_BUFF
;       b_SW4_BUFF
;       b_SW_CTRL
;       b_DISP_SEL
;metodo di chiamata:
;       CALL Sys_Init
;
        MOVLF 0x07,CMCON                ;disabilita comparatori
        BANKSET 1                       ;Bank1
        MOVLF 0x80,OPTION_REG           ;
        MOVLF c_TRISA_VALUE,TRISA       ;imposta I/O port A
        MOVLF c_TRISB_VALUE,TRISB       ;imposta I/O port B
        BANKSET 0                       ;Bank0
        CLRF PORTB                      ;porta tutte le uscite a 0
        CLRF PORTA                      ;
        CLRF b_CONTROLLO                ;clear byte controllo
        CLRF b_STATO                    ;clear byte stato
        CLRF b_SW1_BUFF                 ;clear buffer tasto 1
        CLRF b_SW2_BUFF                 ;clear buffer tasto 2
        CLRF b_SW3_BUFF                 ;clear buffer tasto 3
        CLRF b_SW4_BUFF                 ;clear buffer tasto 4
        CLRF b_SW_CTRL                  ;clear byte di controllo tasti
        CLRF b_DISP_SEL                 ;clear byte selezione display
        RETURN

Sys_Ctrl:
;Controllo selezione display e pulsanti
; gestioni varie di sistema
;Registri modificati:
;       sistema
;       INDF
;       b_CONTROLLO
;       b_STATO
;       b_DISPLAY
;       b_CTRL
;metodo di chiamata:
;       CALL Sys_Ctrl
;
        BTFSC f_FIRST                   ;verifica se attivo primo blocco
        GOTO SY_101                     ; si, salta
        BTFSC f_SECOND                  ;verifica se attivo secondo blocco
        GOTO SY_201                     ; si, salta
        BTFSC f_THIRD                   ;verifica se attivo terzo blocco
        GOTO SY_301                     ; si, salta
        BTFSC f_FOURTH                  ;verifica se attivo quarto blocco
        GOTO SY_401                     ; si, salta
        RETURN                          ;errore, lascia stare tutto
SY_101  BCF f_FIRST                     ;cambia blocco
        BSF f_SECOND
        MOVLF b_DISP_DATA1,FSR          ;carica il byte da visualizzare
        CALL Bcd27seg                   ;converte a 7 segmenti per la visualizzazione
        MOVWF b_DISPLAY                 ;scrive il risultato sul byte display
        BTFSS f_INIT                    ;controlla se in init
        GOTO SY_500                     ; no, salta lampeggio display
        BTFSS f_DISP1_SEL               ;controlla se selezionato Display 1
        GOTO SY_500                     ; no, passa alla scrittura sui buffers
        BTFSC f_DISP_BLINK              ;si, gestione lampeggio display
        CLRF b_DISPLAY
        GOTO SY_500                     ;passa alla scrittura sui buffers
SY_201  BCF f_SECOND                    ;cambia blocco
        BSF f_THIRD
        MOVLF b_DISP_DATA2,FSR          ;carica il byte da visualizzare
        CALL Bcd27seg                   ;converte a 7 segmenti per la visualizzazione
        MOVWF b_DISPLAY                 ;scrive il risultato sul byte display
        BTFSS f_INIT                    ;controlla se in init
        GOTO SY_202                     ; no, salta lampeggio display
        BTFSS f_DISP2_SEL               ;controlla se selezionato Display 2
        GOTO SY_202                     ; no
        BTFSC f_DISP_BLINK              ;si, gestione lampeggio display
        CLRF b_DISPLAY
SY_202  BTFSS f_MODE                    ;verifica se deve far lampeggiare il punto
        GOTO SY_500                     ; no, passa alla scrittura sui buffers
        BTFSC f_DOT_BLINK               ;si, modifica byte display
        BSF b_DISPLAY,0
        BTFSC f_INIT                    ;se in init, attiva comunque il punto
        BSF b_DISPLAY,0
        GOTO SY_500                     ;passa alla scrittura sui buffers
SY_301  BCF f_THIRD                     ;cambia blocco
        BSF f_FOURTH
        MOVLF b_DISP_DATA3,FSR          ;carica il byte da visualizzare
        CALL Bcd27seg                   ;converte a 7 segmenti per la visualizzazione
        MOVWF b_DISPLAY                 ;scrive il risultato sul byte display
        BTFSS f_INIT                    ;controlla se in init
        GOTO SY_500                     ; no, salta lampeggio display
        BTFSS f_DISP3_SEL               ;controlla se selezionato Display 3
        GOTO SY_500                     ; no, passa alla scrittura sui buffers
        BTFSC f_DISP_BLINK              ;si, gestione lampeggio display
        CLRF b_DISPLAY
        GOTO SY_500                     ;passa alla scrittura sui buffers
SY_401  BCF f_FOURTH                    ;cambia blocco
        BSF f_FIRST
        MOVLF b_DISP_DATA0,FSR          ;carica il byte da visualizzare
        CALL Bcd27seg                   ;converte a 7 segmenti per la visualizzazione
        MOVWF b_DISPLAY                 ;scrive il risultato sul byte display
        BTFSS f_INIT                    ;controlla se in init
        GOTO SY_402                     ; no, salta lampeggio display
        BTFSS f_DISP0_SEL               ;controlla se selezionato Display 0
        GOTO SY_402                     ; no
        BTFSC f_DISP_BLINK              ;si, gestione lampeggio display
        CLRF b_DISPLAY
SY_402  BTFSC f_MODE                    ;verifica se deve far lampeggiare il punto
        GOTO SY_500                     ;no, passa alla scrittura sui buffers
        BTFSC f_DOT_BLINK               ;si, modifica byte display
        BSF b_DISPLAY,0
        BTFSC f_INIT                    ;se in init, attiva comunque il punto
        BSF b_DISPLAY,0
SY_500  MOVFF b_CONTROLLO,b_CTRL        ;copia byte controllo sul byte di output
        MOVLW 0x1F
        ANDWF b_CTRL,F                  ;maschera per azzerare bit pulsanti
        BTFSC b_CONTROLLO,0             ;impostazione del pulsante attivo
        BSF b_CTRL,5                    ; select
        BTFSC b_CONTROLLO,1
        BSF b_CTRL,7                    ; add
        BTFSC b_CONTROLLO,2
        BSF b_CTRL,6                    ; sub
        MOVLF b_CTRL,FSR                ;carica il byte dei controlli
        CALL Buff_Write                 ;scrive sui registri
        MOVLF b_DISPLAY,FSR             ;carica il byte display
        CALL Buff_Write                 ;scrive sui registri
        CALL Buff_Strobe                ;colpo di strobe 
        BSF c_REG_OE_PORT,c_REG_OE_PIN  ;output enable
        RETURN

Sec_Cnt:
;Conta fino a 0 e riparte da 9999
;Registri modificati:
;       sistema
;       b_STATO
;       b_DISP_DATA0
;       b_DISP_DATA1
;       b_DISP_DATA2
;       b_DISP_DATA3
;metodo di chiamata:
;       CALL Sec_Cnt
;
        DECFSZ b_DISP_DATA0,F           ;decrementa i secondi
        RETURN                          ;risultato > 0, esce
        MOVLF 0xA,b_DISP_DATA0          ;risultato = 0, carica 9 e decrementa le decine
        DECFSZ b_DISP_DATA1,F
        RETURN                          ;risultato > 0, esce
        MOVLF 0xA,b_DISP_DATA1          ;risultato = 0, carica 9 e decrementa le centinaia
        DECFSZ b_DISP_DATA2,F
        RETURN                          ;risultato > 0, esce
        MOVLF 0xA,b_DISP_DATA2          ;risultato = 0, carica 9 e decrementa le migliaia
        DECFSZ b_DISP_DATA3,F
        RETURN                          ;risultato > 0, esce
        MOVLF 0x1,b_DISP_DATA0          ;risultato = 0, carica 0 su tutti i display
        MOVLF 0x1,b_DISP_DATA1
        MOVLF 0x1,b_DISP_DATA2
        MOVLF 0x1,b_DISP_DATA3
        BSF f_TMR_END                   ;attiva flag di fine conteggio
        RETURN

Min_Cnt:
;Conta fino a 0 e riparte da 99.59
;Registri modificati:
;       sistema
;       b_STATO
;       b_DISP_DATA0
;       b_DISP_DATA1
;       b_DISP_DATA2
;       b_DISP_DATA3
;metodo di chiamata:
;       CALL Min_Cnt
;
        DECFSZ b_DISP_DATA0,F           ;decrementa i secondi
        RETURN                          ;risultato > 0, esce
        MOVLF 0xA,b_DISP_DATA0          ;risultato = 0, carica 9 e decrementa le decine di secondi
        DECFSZ b_DISP_DATA1,F
        RETURN                          ;risultato > 0, esce
        MOVLF 0x6,b_DISP_DATA1          ;risultato = 0, carica 9 e decrementa i minuti
        DECFSZ b_DISP_DATA2,F
        RETURN                          ;risultato > 0, esce
        MOVLF 0xA,b_DISP_DATA2          ;risultato = 0, carica 9 e decrementa le decine di minuti
        DECFSZ b_DISP_DATA3,F
        RETURN                          ;risultato > 0, esce
        MOVLF 0x1,b_DISP_DATA0          ;risultato = 0, carica 0 su tutti i display
        MOVLF 0x1,b_DISP_DATA1
        MOVLF 0x1,b_DISP_DATA2
        MOVLF 0x1,b_DISP_DATA3
        BSF f_TMR_END                   ;attiva flag di fine conteggio
        RETURN

